# Coverage for Doctrine_Hook_Parser_Complex

Back to coverage report

1 | <?php
2 | /*
3 | * $Id: Complex.php 3212 2007-11-24 18:58:33Z romanb $
4 | *
5 | * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
6 | * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
7 | * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
8 | * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
9 | * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
10 | * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
11 | * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
12 | * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
13 | * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
14 | * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
15 | * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
16 | *
17 | * This software consists of voluntary contributions made by many individuals
18 | * and is licensed under the LGPL. For more information, see
19 | * <http://www.phpdoctrine.org>.
20 | */
21 | Doctrine::autoload('Doctrine_Hook_Parser');
22 | /**
23 | * Doctrine_Hook_Parser_Complex
24 | *
25 | * @package Doctrine
26 | * @subpackage Hook
27 | * @license http://www.opensource.org/licenses/lgpl-license.php LGPL
28 | * @link www.phpdoctrine.org
29 | * @since 1.0
30 | * @version $Revision: 3212 $
31 | * @author Konsta Vesterinen <kvesteri@cc.hut.fi>
32 | */
33 | abstract class Doctrine_Hook_Parser_Complex extends Doctrine_Hook_Parser
34 | {
35 | protected $_tokenizer;
36 |
37 | /**
38 | * Constructor.
39 | */
40 | public function __construct()
41 | {
42 | $this->_tokenizer = new Doctrine_Query_Tokenizer();
43 | }
44 |
45 | /**
46 | * parse
47 | * Parses given field and field value to DQL condition
48 | * and parameters. This method should always return
49 | * prepared statement conditions (conditions that use
50 | * placeholders instead of literal values).
51 | *
52 | * @param string $alias component alias
53 | * @param string $field the field name
54 | * @param mixed $value the value of the field
55 | * @return void
56 | */
57 | public function parse($alias, $field, $value)
58 | {
59 | $this->condition = $this->parseClause($alias, $field, $value);
60 | }
61 |
62 | /**
63 | * parseClause
64 | *
65 | * @param string $alias component alias
66 | * @param string $field the field name
67 | * @param mixed $value the value of the field
68 | * @return void
69 | */
70 | public function parseClause($alias, $field, $value)
71 | {
72 | $parts = $this->_tokenizer->quoteExplode($value, ' AND ');
73 |
74 | if (count($parts) > 1) {
75 | $ret = array();
76 | foreach ($parts as $part) {
77 | $ret[] = $this->parseSingle($alias, $field, $part);
78 | }
79 |
80 | $r = implode(' AND ', $ret);
81 | } else {
82 | $parts = $this->_tokenizer->quoteExplode($value, ' OR ');
83 | if (count($parts) > 1) {
84 | $ret = array();
85 | foreach ($parts as $part) {
86 | $ret[] = $this->parseClause($alias, $field, $part);
87 | }
88 |
89 | $r = implode(' OR ', $ret);
90 | } else {
91 | $ret = $this->parseSingle($alias, $field, $parts[0]);
92 | return $ret;
93 | }
94 | }
95 | return '(' . $r . ')';
96 | }
97 |
98 | /**
99 | * parseSingle
100 | *
101 | * @param string $alias component alias
102 | * @param string $field the field name
103 | * @param mixed $value the value of the field
104 | * @return void
105 | */
106 | abstract public function parseSingle($alias, $field, $value);
107 | }